#include <linux/module.h>
#include <linux/init.h>

MODULE_LICENSE("Dual BSD/GPL");

#include "silly.h"

struct file_operations silly_fops = {
        .open =     silly_open,
        .release =  silly_release,
        .owner =    THIS_MODULE
};

int silly_major = 0;

static __init int silly_init (void) {
  int result;
  
  result = register_chrdev(silly_major, "silly", &silly_fops);
  if (result < 0) {
    printk(KERN_INFO "silly: can't get major number\n");
    return result;
  }

  if (silly_major == 0)
    silly_major = result;

  printk (KERN_ALERT "Silly is up and running\n");
  	
  return 0;
}

static __exit void silly_cleanup(void) {
  unregister_chrdev(silly_major, "silly");
  printk (KERN_ALERT "bye bye\n");

  return;
}

module_init(silly_init);
module_exit(silly_cleanup);
