#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <unistd.h>
#include <string.h>
#include <alloca.h>

#include <stdio.h>

int main (int argc, char ** argv)
{
  int fd;
  char * buf;
  size_t siz;

  char buffer1[]="test1";
  char buffer2[]="test2";   

  if (argc != 2) {
    fprintf (stderr, "usage: %s devicefile\n", argv[0]);
    return 1;
  }

  if ( (fd = open (argv[1], O_WRONLY)) < 0)
  {
    fprintf (stderr, "open error\n");
    return 1;
  }

  if (write (fd, buffer1, strlen(buffer1)) < 0) 
  {
    fprintf (stderr, "write error\n");
    close(fd);
    return 1;
  }

  if (write (fd, buffer2, strlen(buffer2)+1) < 0) 
  {
    fprintf (stderr, "write error\n");
    close(fd);
    return 1;
  }
	
  close(fd);

  if ( (fd = open (argv[1], O_RDONLY)) < 0)
  {
    fprintf (stderr, "open error\n");
    return 1;
  }

  siz = strlen(buffer1)+strlen(buffer2)+1;
  buf = alloca (siz);
  bzero (buf, siz);

  if (read(fd, buf, siz) != (ssize_t) siz)
  {
    fprintf (stderr, "read problem (%s)\n", buf);
    return 1;
  }

  fprintf (stdout, "\"%s\"\n", buf);

  close(fd);

  return 0;
}
